
void error(char* p) { printf(p); exit(1); }
	// prints a single string and exits

int sortfn(const void *p1, const void *p2)
{// comparison function for a quick sort algorithm (from the standard library)
	sort_face* a1 = (sort_face*)p1;
	sort_face* a2 = (sort_face*)p2;

	if(a1->distance > a2->distance) return -1;
	else if(a1->distance < a2->distance) return 1;
	else return 0;
}

void to_2d(vertex* v)
{	// perspective projection
	static long xadd = getmaxx()/2;
	static long yadd = getmaxy()/2;

	static long d = 300;

	v->drawx = long( (v->x*d)/(v->z+d+1000)+xadd );
	v->drawy = long( (v->y*d)/(v->z+d+1000)+yadd );

	return;
}

void rotate_lamp(vertex* lamp,double alfa,double beta)
{// rotates lamp around two axis ( x and y ) using given angles

	matrix Mx(1, 0 		 , 0, 		0,
				 0, cos(beta),-sin(beta), 0,
				 0, sin(beta), cos(beta), 0,
				 0, 0			 , 0, 		1);

	matrix My(cos(alfa), 0, sin(alfa), 0,
				 0, 1, 0, 0,
				 -sin(alfa),0, cos(alfa), 0,
				 0, 0			 , 0, 		1);

	matrix transform = My*Mx;

	transform.rotate(lamp);
	transform.rotatenorm(lamp);

	return;
}
long test_visibility(face faces[],
	sort_face sort_faces[],const long no)
{// tests visiblity the faces using the z-component of the cross product
 // of two vectors of the trinngle
 // if it's negative, the face is invisible
 // it also calculates the distance from the obserwer for every visible face
 // this distance and the pointer to each visible face is put to "sort_faces"
 // table.

		long v1x,v1y,v2x,v2y,Nz,index=0;
		for (long a=0; a<no; a++)
		{
			v1x = faces[a].P2->drawx-faces[a].P1->drawx;
			v1y = faces[a].P2->drawy-faces[a].P1->drawy;

			v2x = faces[a].P2->drawx-faces[a].P3->drawx;
			v2y = faces[a].P2->drawy-faces[a].P3->drawy;

			Nz = v1x*v2y - v1y*v2x;

			if ( Nz > 0 )
			{
				sort_faces[index].address = &faces[a];
				sort_faces[index++].distance =
				long(faces[a].P1->z + faces[a].P2->z+faces[a].P3->z);
			}
		}
	sort_faces[index].address = 0;
	sort_faces[index+1].address = 0;
	return index;
}

void draw_light(vertex lamp)
{// draws this little cross which symbolises the light source
	to_2d(&lamp);
	int a;
	for(a=-5;a<=5;a++)
		screen2[320*(lamp.drawy+a)+lamp.drawx] = 250;

	for(a=-5;a<=5;a++)
		screen2[320*lamp.drawy+lamp.drawx+a] = 250;
}



/*********** graphics procedures ***********/
int init_gfx(void)
{// using BGI
	int gdriver, gmode=0, errorcode;

	gdriver = installuserdriver("svga256", NULL );
	/* initialize graphics mode */

	initgraph(&gdriver, &gmode, "");

	/* read result of initialization */
	errorcode = graphresult();

	if (errorcode != grOk)    /* an error occurred */
	{
		printf("Graphics error: %s\n", grapherrormsg(errorcode));
		printf("Press any key to halt:");
		getch();
		exit(1);               /* return with error code */
	}
}

inline void gfx_exit(void)
{// I don't need to explain it
	closegraph();
	return;
}
void to_screen(void)
{
	unsigned char far* p1 = screen2;
	unsigned char far* p2 = (unsigned char far *)0xa0000000l;
	unsigned char far* p3 = screen3;

	for(long a = 0;a<64000l;a++)
	{
		*p2++ = *p1;	// buffer to the screen
		*p1++ = *p3++;	// picture to the buffer
	}
}
/***************************************************/
