int objraw;
char palfile[13];
char objfile[13];
char picfile[13];


char rl[256];
#include <ctype.h>

int read_line(FILE* f)
{
	int i,c;
	for(i=0,c=getc(f);c!=EOF && c!='\n' && i<20;c=getc(f))
		rl[i++] = c;
	rl[i] = '\0';
	if(c!=EOF && c!='\n')
		for(c=getc(f);c!=EOF && c!='\n';c=getc(f));

	return i;
}
char cfgerr[] = "config file is corrupt";

void read_config(void)
{


	FILE* config = fopen("phong.cfg","rt");
	if(!config) error("Cannot open config file\n");

	if(!read_line(config)) error(cfgerr);

	if(rl[0]=='R' && rl[1]=='A' && rl[2]=='W') objraw = 1;
	else objraw = 0;

	if(!read_line(config)) error(cfgerr);
	for(int i=0;(isalnum(rl[i]) || rl[i]=='.') && i<15;i++)
		objfile[i] = rl[i];
		objfile[i] = '\0';

	if(!read_line(config)) error(cfgerr);
	for(i=0;(isalnum(rl[i]) || rl[i]=='.') && i<15;i++)
		picfile[i] = rl[i];
		picfile[i] = '\0';

	if(!read_line(config)) error(cfgerr);
	for(i=0;(isalnum(rl[i]) || rl[i]=='.') && i<15;i++)
		palfile[i] = rl[i];
		palfile[i] = '\0';

	return;
}

void read_file(vertex* vertices,long maxv,face* faces,long maxf,
		long &nov,long &nof)
{
	FILE* infile;

	printf("Opening object...\n");
	if(!(infile=fopen(objfile,"rt")) )
		error("Cannot open given file!\n");

	if(fgetc(infile)!='3') error("file is corrupt\n");
	if(fgetc(infile)!='D') error("file is corrupt\n");
	if(fgetc(infile)!='G') error("file is corrupt\n");
	if(fgetc(infile)!='1') error("file is corrupt\n");
	if(fgetc(infile)!='\n') error("file is corrupt\n");


	if(!fscanf(infile,"%D",&nov) ) error("file is corrupt");

	if(nov > maxv) error("too many vertices");

	int a;
	double Xscan,Yscan,Zscan;
	for(a = 0; a<nov;a++)
	{
		if( !fscanf(infile,"%lf%lf%lf",&Xscan,&Yscan,&Zscan) ) error("file is corrupt");
		vertices[a].globalx = Xscan*256*2;
		vertices[a].globaly = Yscan*256*2;
		vertices[a].globalz = Zscan*256*2;
	}
	int dummy;
	long a1,a2,a3,c;
	while( !feof(infile) )
	{
		if(!fscanf(infile,"%d",&dummy) ) break;
		if(feof(infile) )break;
		if(dummy!=3) error("faces may be only from triangles!");

		if(!fscanf(infile,"%D%D%D%D",&a1,&a2,&a3,&c) )
			 error("file is corrupt");

		faces[nof].P1 = &vertices[a1];
		faces[nof].P2 = &vertices[a2];
		faces[nof].P3 = &vertices[a3];

		nof++;
		if( nof>=maxf-1) error("too many faces");
	}
	fclose(infile);
	return;
}


void read_raw(vertex* vertices,long maxv,face* faces,
				long maxf,long &nov,long &nof)
{
	FILE* infile;

	printf("Opening object...\n");
	if(!(infile=fopen(objfile,"rt")) )
		error("Cannot open given object file!\n");

	double X1,Y1,Z1;
	double X2,Y2,Z2;
	double X3,Y3,Z3;

	while( !feof(infile) )
	{
		int a;
		int found = 0;


		if(!fscanf(infile,"%lf",&X1) ) break;
		if(feof(infile) )break;

		if(!fscanf(infile,"%lf%lf%lf%lf%lf%lf%lf%lf",
							&Y1,&Z1,&X2,&Y2,&Z2,&X3,&Y3,&Z3) )
			 error("file is corrupt");
		X1*=1000;
		Y1*=1000;
		Z1*=1000;
		X2*=1000;
		Y2*=1000;
		Z2*=1000;
		X3*=1000;
		Y3*=1000;
		Z3*=1000;

		for(a=0;a<nov;a++)
			if( vertices[a].globalx-1<X1 &&
				 vertices[a].globaly-1<Y1 &&
				 vertices[a].globalz-1<Z1 &&
				 vertices[a].globalx+1>X1 &&
				 vertices[a].globaly+1>Y1 &&
				 vertices[a].globalz+1>Z1)
			{
				faces[nof].P1 = &vertices[a];
				found = 1;
				break;
			}
		if(!found)
		{
			vertices[nov].globalx = X1;
			vertices[nov].globaly = Y1;
			vertices[nov].globalz = Z1;
			faces[nof].P1 = &vertices[nov];
			nov++;
		}
		found = 0;

		for(a=0;a<nov;a++)
			if( vertices[a].globalx-1<X2 &&
				 vertices[a].globaly-1<Y2 &&
				 vertices[a].globalz-1<Z2 &&
				 vertices[a].globalx+1>X2 &&
				 vertices[a].globaly+1>Y2 &&
				 vertices[a].globalz+1>Z2)
			{
				faces[nof].P3 = &vertices[a];
				found = 1;
				break;
			}
		if(!found)
		{
			vertices[nov].globalx = X2;
			vertices[nov].globaly = Y2;
			vertices[nov].globalz = Z2;
			faces[nof].P3 = &vertices[nov];
			nov++;
		}
		found = 0;


		for(a=0;a<nov;a++)
			if( vertices[a].globalx-1<X3 &&
				 vertices[a].globaly-1<Y3 &&
				 vertices[a].globalz-1<Z3 &&
				 vertices[a].globalx+1>X3 &&
				 vertices[a].globaly+1>Y3 &&
				 vertices[a].globalz+1>Z3)
			{
				faces[nof].P2 = &vertices[a];
				found = 1;
				break;
			}
		if(!found)
		{
			vertices[nov].globalx = X3;
			vertices[nov].globaly = Y3;
			vertices[nov].globalz = Z3;
			faces[nof].P2 = &vertices[nov];
			nov++;
		}
		found = 0;


		nof++;

		if(nov>maxv-5) error("Too many vertices");
		if(nof>maxf-3) error("Too many faces");
	}
	return;
}
void read_picture(unsigned char* pic)
{
	int handle;

	if ((handle =
		open(picfile, O_RDONLY | O_BINARY, S_IWRITE | S_IREAD)) == -1)
		error("Error opening bckground picture\n");

	if ( read(handle,pic, 64000u) == -1)
		error("Picture Read Failed.\n");

	return;
}

void setup_palette(void) // load palette
{
	unsigned char paleta[256*3];
	int handle;

	if ((handle =
		open(palfile, O_RDONLY | O_BINARY, S_IWRITE | S_IREAD)) == -1)
			gfx_exit(), error("Error Opening Palette File\n");

	if ( read(handle,paleta, 256*3) == -1)
		 gfx_exit(), error("Palette Read Failed.\n");

	for (int l=0; l<256; l++)
		setrgbpalette(l,paleta[l*3]/4,paleta[l*3+1]/4,paleta[l*3+2]/4);

	return;
}

void calculate_N_vektor(face* f)
{// caculates a unit normal vector for the face
 // and adds the normal vector to all vertices of this face

	double X1 = f->P1->globalx;
	double Y1 = f->P1->globaly;
	double Z1 = f->P1->globalz;
	double X2 = f->P2->globalx;
	double Y2 = f->P2->globaly;
	double Z2 = f->P2->globalz;
	double X3 = f->P3->globalx;
	double Y3 = f->P3->globaly;
	double Z3 = f->P3->globalz;

	double Xa = X2-X1;
	double Ya = Y2-Y1;
	double Za = Z2-Z1;
	double Xb = X2-X3;
	double Yb = Y2-Y3;
	double Zb = Z2-Z3;

	double Nx = -Ya*Zb + Yb*Za;
	double Ny = -Xb*Za + Xa*Zb;
	double Nz = -Xa*Yb + Xb*Ya;

	double dl = sqrt(Nx*Nx+Ny*Ny+Nz*Nz);
	if (dl)
	{
		Nx /= -dl;
		Ny /= -dl;
		Nz /= -dl;
	}
	else
	{
		Nx = 0;
		Ny = 0;
		Nz = 0;
	}

	// we add the normal vector to all vertices of this face

	f->P1->normx += Nx;
	f->P1->normy += Ny;
	f->P1->normz += Nz;

	f->P2->normx += Nx;
	f->P2->normy += Ny;
	f->P2->normz += Nz;

	f->P3->normx += Nx;
	f->P3->normy += Ny;
	f->P3->normz += Nz;
	return;
}

void calculate_points_N_vektor(vertex* P)
{ // makes the normal vector of this face be unit
	double dl = sqrt( P->normx*P->normx+P->normy*P->normy+P->normz*P->normz );
	if (dl)
	{
		P->normx /=dl;
		P->normy /=dl;
		P->normz /=dl;
	}
	return;
}

void compute_env_map(void)
{
	// aproximation of phong shading
	// we use H o N instead of N o L and Rl o V

	int i,j;

	double x, y, z;

	double temp;
	double m = 30,z1;	// we must modify m coeficient (must be larger)

	int col;
	for(i=0;i<256;i++)		// 0<=i<=255
		for(j=0;j<256;j++)	// 0<=j<=255
		{
			x = i-127.5;			// -127.5<=i<=127.5
			y = j-127.5;			// -127.5<=j<=127.5
			x/= 127.5;
			y/= 127.5;				// -1<x,y<1

			temp = 1-x*x-y*y;
			if(temp<0) env_map[256*i+j] = 0;
			else
			{
				z = sqrt(temp);
				col=z*z*z*30;		// its better to use z^3 instead of z
				z1 = pow(z,m);		// for diffuse refraction
				col += z1*250;
				if(col>250) col = 250;
				env_map[256*i+j]=col;
			}
		}
}

