class matrix{
private:
	double m[4][4];			// 4 x 4 matrix
						// used to transform objects
public:
	matrix(double a1, double a2, double a3, double a4,
			 double b1, double b2, double b3, double b4,
			 double c1, double c2, double c3, double c4,
			 double d1, double d2, double d3, double d4)
	{
		m[0][0] = a1;	m[0][1] = a2;	m[0][2] = a3;	m[0][3] = a4;
		m[1][0] = b1;	m[1][1] = b2;	m[1][2] = b3;	m[1][3] = b4;
		m[2][0] = c1;	m[2][1] = c2;	m[2][2] = c3;	m[2][3] = c4;
		m[3][0] = d1;	m[3][1] = d2;	m[3][2] = d3;	m[3][3] = d4;
	}		// constructor
	matrix(void)
	{
		m[0][0] = 0;	m[0][1] = 0;	m[0][2] = 0;	m[0][3] = 0;
		m[1][0] = 0;	m[1][1] = 0;	m[1][2] = 0;	m[1][3] = 0;
		m[2][0] = 0;	m[2][1] = 0;	m[2][2] = 0;	m[2][3] = 0;
		m[3][0] = 0;	m[3][1] = 0;	m[3][2] = 0;	m[3][3] = 0;
	}		// constructor

	friend matrix operator*(matrix,matrix);
	void rotate(vertex*);
	void rotatenorm(vertex* p); // rotates Vnormal using matrix
	void rotatenorm2(vertex* p); // rotates Vnormal using matrix
	void trans(void);
};

void matrix::rotate(vertex* p)	// rotates vertex using matrix
{
	p->x = p->globalx*m[0][0] + p->globaly*m[0][1] + p->globalz*m[0][2];
	p->y = p->globalx*m[1][0] + p->globaly*m[1][1] + p->globalz*m[1][2];
	p->z = p->globalx*m[2][0] + p->globaly*m[2][1] + p->globalz*m[2][2];
}
void matrix::rotatenorm(vertex* p) // rotates Vnormal using matrix
{
	p->nx = p->normx*m[0][0] + p->normy*m[0][1] + p->normz*m[0][2];
	p->ny = p->normx*m[1][0] + p->normy*m[1][1] + p->normz*m[1][2];
	p->nz = p->normx*m[2][0] + p->normy*m[2][1] + p->normz*m[2][2];
}
void matrix::rotatenorm2(vertex* p) // rotates Vnormal using matrix
{
	p->nx2 = p->normx*m[0][0] + p->normy*m[0][1] + p->normz*m[0][2];
	p->ny2 = p->normx*m[1][0] + p->normy*m[1][1] + p->normz*m[1][2];
	p->nz2 = p->normx*m[2][0] + p->normy*m[2][1] + p->normz*m[2][2];
}

matrix operator*(matrix M1,matrix M2)	// a product of two matrices
{
	matrix M;
	int i,j,k;
	for(i=0;i<4;i++)
		for(j=0;j<4;j++)
			for(k=0;k<4;k++)
				M.m[i][j] += (M1.m[i][k])*(M2.m[k][j]);
	return M;
}
void swapel(double &p, double &q)	// for the function below
{
	double temp = p;
	p = q;
	q = temp;
}

void matrix::trans(void) 	// inverts given matrix
{
	int i,j;
	for(i=1;i<4;i++)
		for(j=0;j<i;j++)
			swapel(m[i][j],m[j][i]);
}

